__version__ = 1, 1, 1
__author__ = '竹永康'
__author_email__ = 'zhuyk4@lenovo.com'


class IsddcCrypto:
    """A reversible encryption technique based on Unicode Code."""

    def __init__(self, offset: int = None, split: str = None):
        """
        @param offset:
            Specifies the Unicode Code offset, default -1
            Encryption and decryption must use the same value.
        @param split:
            A string used to split encrypted data, default "."
            Encryption and decryption must use the same value.
        """

    def encrypt(self, cleartext: str) -> str:
        """
        @param cleartext: The string to be encrypt.
        @return:          The encrypted value.
        """

    def decrypt(self, ciphertext: str) -> str:
        """
        @param ciphertext: The string to be decrypt.
        @return:           The decrypted value.
        """


class MD5:

    def __new__(cls, data: 'Any' = None):
        """
        @param data: Data to be encrypt.

        if data is None:
            return object.__new__(cls)
        else:
            return md5-value of data.
        """

    def update(self, data: 'Any'):
        """Add or append a segment of data to encrypt."""

    def update_str(self, data: str):
        """Add or append a string to encrypt."""

    @property
    def hexdigest(self) -> str:
        """Execute encryption program and return md5-value."""


def encrypt(cleartext: str, *, offset: int = None, split: str = None) -> str:
    """Encrypts the string and returns the encrypted value."""
    return IsddcCrypto(offset, split).encrypt(cleartext)


def decrypt(ciphertext: str, *, offset: int = None, split: str = None) -> str:
    """Decrypt the ciphertext and return the decrypted value."""
    return IsddcCrypto(offset, split).decrypt(ciphertext)


class _______i________s________d_______d_______c_______:
    import sys

    __import__(f'{__name__}.i {__name__[6:]}')
    ipack = sys.modules[__name__]
    icode = globals()[f'i {__name__[6:]}']

    for iname, ifunc in globals().items():
        if iname[0] != '_' and hasattr(icode, iname):
            setattr(ipack, iname, getattr(icode, iname))


from typing import Any
